﻿//BERNARDO DEL CASTILLO - RAPTUS GAMES 2014
Shader "Custom/BasicBlur" {
	Properties {
	}
	CGINCLUDE
	#include "UnityCG.cginc"
	sampler2D 				_IMGtoBlur;
	half					_Blur;
	half					_DistanceBlur;
	int 					_Horiz;
	half2 			v_blurTexCoords[14];
	
	struct v2f {
		half4 pos : POSITION;
		half2 uv : TEXCOORD0;
	};
	
	v2f vert( appdata_img v )
	{
		v2f o;
		o.pos = mul (UNITY_MATRIX_MVP, v.vertex);
		o.uv = v.texcoord;
		
		return o;
	} 
	
	void composeHorizTexCoords( half2 _texCoord )
	{
		half finalBlur = _Blur+ (_Blur * _DistanceBlur * _DistanceBlur);
		
		v_blurTexCoords[ 0] = _texCoord + half2(-0.028, 0.0)* finalBlur;
	    v_blurTexCoords[ 1] = _texCoord + half2(-0.024, 0.0)* finalBlur;
	    v_blurTexCoords[ 2] = _texCoord + half2(-0.020, 0.0)* finalBlur;
	    v_blurTexCoords[ 3] = _texCoord + half2(-0.016, 0.0)* finalBlur;
	    v_blurTexCoords[ 4] = _texCoord + half2(-0.012, 0.0)* finalBlur;
	    v_blurTexCoords[ 5] = _texCoord + half2(-0.008, 0.0)* finalBlur;
	    v_blurTexCoords[ 6] = _texCoord + half2(-0.004, 0.0)* finalBlur;
	    v_blurTexCoords[ 7] = _texCoord + half2( 0.004, 0.0)* finalBlur;
	    v_blurTexCoords[ 8] = _texCoord + half2( 0.008, 0.0)* finalBlur;
	    v_blurTexCoords[ 9] = _texCoord + half2( 0.012, 0.0)* finalBlur;
	    v_blurTexCoords[10] = _texCoord + half2( 0.016, 0.0)* finalBlur;
	    v_blurTexCoords[11] = _texCoord + half2( 0.020, 0.0)* finalBlur;
	    v_blurTexCoords[12] = _texCoord + half2( 0.024, 0.0)* finalBlur;
	    v_blurTexCoords[13] = _texCoord + half2( 0.028, 0.0)* finalBlur;
	}
	
	void composeVertTexCoords( half2 _texCoord )
	{
		half finalBlur = _Blur+ (_Blur * _DistanceBlur * _DistanceBlur);
		
	    v_blurTexCoords[ 0] = _texCoord + half2(0.0, -0.028)* finalBlur;
	    v_blurTexCoords[ 1] = _texCoord + half2(0.0, -0.024)* finalBlur;
	    v_blurTexCoords[ 2] = _texCoord + half2(0.0, -0.020)* finalBlur;
	    v_blurTexCoords[ 3] = _texCoord + half2(0.0, -0.016)* finalBlur;
	    v_blurTexCoords[ 4] = _texCoord + half2(0.0, -0.012)* finalBlur;
	    v_blurTexCoords[ 5] = _texCoord + half2(0.0, -0.008)* finalBlur;
	    v_blurTexCoords[ 6] = _texCoord + half2(0.0, -0.004)* finalBlur;
	    v_blurTexCoords[ 7] = _texCoord + half2(0.0,  0.004)* finalBlur;
	    v_blurTexCoords[ 8] = _texCoord + half2(0.0,  0.008)* finalBlur;
	    v_blurTexCoords[ 9] = _texCoord + half2(0.0,  0.012)* finalBlur;
	    v_blurTexCoords[10] = _texCoord + half2(0.0,  0.016)* finalBlur;
	    v_blurTexCoords[11] = _texCoord + half2(0.0,  0.020)* finalBlur;
	    v_blurTexCoords[12] = _texCoord + half2(0.0,  0.024)* finalBlur;
	    v_blurTexCoords[13] = _texCoord + half2(0.0,  0.028)* finalBlur;
	}
	
	half4 GaussianBlur(v2f IN) : COLOR
	{
		
		
		half2 coords = IN.uv;	
		 _DistanceBlur = 1 - tex2D(_IMGtoBlur, IN.uv).a;
		
		if (_Horiz == 1){
			composeHorizTexCoords(IN.uv);
		}
		else
		{
			composeVertTexCoords(IN.uv);
		}
		
		 half4 _FragColor = half4(0,0,0,0);
		 
	    _FragColor += tex2D(_IMGtoBlur, v_blurTexCoords[ 0])*0.0044299121055113265;
	    _FragColor += tex2D(_IMGtoBlur, v_blurTexCoords[ 1])*0.00895781211794;
	    _FragColor += tex2D(_IMGtoBlur, v_blurTexCoords[ 2])*0.0215963866053;
	    _FragColor += tex2D(_IMGtoBlur, v_blurTexCoords[ 3])*0.0443683338718;
	    _FragColor += tex2D(_IMGtoBlur, v_blurTexCoords[ 4])*0.0776744219933;
	    _FragColor += tex2D(_IMGtoBlur, v_blurTexCoords[ 5])*0.115876621105;
	    _FragColor += tex2D(_IMGtoBlur, v_blurTexCoords[ 6])*0.147308056121;
	    _FragColor += tex2D(_IMGtoBlur, coords)*			 0.159576912161;
	    _FragColor += tex2D(_IMGtoBlur, v_blurTexCoords[ 7])*0.147308056121;
	    _FragColor += tex2D(_IMGtoBlur, v_blurTexCoords[ 8])*0.115876621105;
	    _FragColor += tex2D(_IMGtoBlur, v_blurTexCoords[ 9])*0.0776744219933;
	    _FragColor += tex2D(_IMGtoBlur, v_blurTexCoords[10])*0.0443683338718;
	    _FragColor += tex2D(_IMGtoBlur, v_blurTexCoords[11])*0.0215963866053;
	    _FragColor += tex2D(_IMGtoBlur, v_blurTexCoords[12])*0.00895781211794;
	    _FragColor += tex2D(_IMGtoBlur, v_blurTexCoords[13])*0.0044299121055113265;
	    
	     //_FragColor = half4(1,1,1,1) - _FragColor;
	     //_FragColor.g = _FragColor.b = 0;
		
		return _FragColor;
	  
	}
	ENDCG
	
	Subshader {
		ZTest Off
		Cull Off
		ZWrite Off
		Fog { Mode off }
		
	//Pass 0 Blur
		 Pass 
		 {
		 	Name "GaussianBlur"

		      CGPROGRAM
		      #pragma target 4.0
		      #pragma fragmentoption ARB_precision_hint_fastest 
		      #pragma vertex vert
		      #pragma fragment GaussianBlur
		      ENDCG
	  	}
	} 
}
